#include <iostream>

using namespace std;

const int N = 10;
const int MAXX = 20;

struct BSTNode {
	int data;
	BSTNode* left;
	BSTNode* right;
};

class BST {
	int matrix[MAXX][MAXX];
	
public:
	BSTNode* root;
	BST(int *tab) {
		for (int i = 0; i < MAXX; i++) {
			for (int j = 0; j < MAXX; j++) {
				matrix[i][j] = 0;
			}
		}

		for (int i = 1; i < N; i++) {
			insert(root, tab[i]);
		}
	}

	bool insert(BSTNode*& node, int value) { // polaczenia wiersz > kolumna (przodek > potomek)
		
		if (node == NULL) {          
			node = new BSTNode;
			node->data = value;
			node->left = NULL;
			node->right = NULL;
			return true;
		}
		else {
			if (value < node->data) {
				return insert(node->left, value);
			}
			else if (value > node->data) {
				return insert(node->right, value);
			}
		}

		return false;
	}

	void buildMatrix(BSTNode* node) {
		if (node == NULL) return;
		if (node->left != NULL) {
			matrix[node->data][node->left->data] = 1;
			buildMatrix(node->left);
		}
		if (node->right != NULL) {
			matrix[node->data][node->right->data] = 2;
			buildMatrix(node->right);
		}
	}

	void displayMatrix() {
		cout << endl << endl;
		for (int i = 0; i < MAXX; i++) {
			for (int j = 0; j < MAXX; j++) {
				cout << matrix[i][j] << " ";
			}
			cout << endl;
		}
	}

};

int main() {
	int tab[N]{ 8, 2, 15, 1, 10, 5, 19, 18, 3, 5 };

	for (int i = 0; i < N; i++) {
		cout << tab[i] << " ";
	}

	BST drzewo(tab);

	drzewo.buildMatrix(drzewo.root);

	drzewo.displayMatrix();
}